<?php

define ("VERSION","1.1.3b");

$DBstruct = array(
    "user" => array ( # a user in the system
        "id" => array("integer not null primary key auto_increment","ID"),
        "name" => array("varchar(255) not null","Name"),
        "address1" => array("varchar(255)","Address1"),
        "address2" => array("varchar(255)","Address2"),
        "postcode" => array("varchar(255)","Postcode"),
        "town" => array("varchar(255)","Town"),
        "email" => array("varchar(255)","Email"),
        "confirmed" => array("tinyint default 0","Is this user confirmed"), # added
        "entered" => array("datetime", "Entered"),
        "modified" => array("timestamp", "Modified"),
        "uniqid" => array("varchar(255)","uniqid for user to return")
    ),
    "list" => array ( # a list in the system
        "id" => array("integer not null primary key auto_increment","ID"),
        "name" => array("varchar(255) not null","Name"),
        "description" => array("Text","Description"),
        "entered" => array("datetime","Entered"),
        "listorder" => array("integer","Order of listing"), # added
        "prefix" => array("varchar(10)","Subject prefix"), # added
        "modified" => array("timestamp", "Modified"),
        "active" => array("tinyint","Active")
    ),
    "listuser" => array ( # user subscription to a list
        "userid" => array("integer not null","User ID"),
        "listid" => array("integer not null","List ID"),
        "entered" => array("datetime", "Entered"),
        "modified" => array("timestamp", "Modified"),
        "primary key" => array("(userid,listid)","Primary Key")
    ),
    "message" => array ( # a message
        "id" => array("integer not null primary key auto_increment","ID"),
        "subject" => array("varchar(255) not null","subject"),
        "fromfield" => array("varchar(255) not null","from"),
        "tofield" => array("varchar(255) not null","tofield"),
        "replyto" => array("varchar(255) not null","reply-to"),
        "message" => array("Text","Message"),
        "footer" => array("text","Footer for a message"), # added
        "entered" => array("datetime","Entered"),
        "modified" => array("timestamp", "Modified"),
        "status" => array("enum('submitted','inprocess','sent','cancelled')","Status"), 
        "processed" => array("mediumint unsigned default 0", "Number Processed"),
        "userselection" => array("text","query to select the users for this message"),
        "sent" => array("datetime", "sent")
    ),
    "listmessage" => array ( # linking messages to a list
        "id" => array("integer not null primary key auto_increment","ID"),
        "messageid" => array("integer not null","Message ID"),
        "listid" => array("integer not null","List ID"),
        "entered" => array("datetime", "Entered"),
        "modified" => array("timestamp","Modified")
    ),
    "usermessage" => array ( # linking messages to a user
        #"id" => array("integer not null primary key auto_increment","ID"),
        "messageid" => array("integer not null","Message ID"),
        "userid" => array("integer not null","User ID"),
        "entered" => array("timestamp", "Entered"),
        "primary key" => array("(userid,messageid)","Primary key")
    ),
    "attribute" => array ( # attributes of a user or a message
        "id" => array("integer not null primary key auto_increment","ID"),
        "name" => array("varchar(255) not null","Name"),
        "type" => array("enum('checkbox','radio','select')","Type of attribute"),
        "listorder" => array("integer","order of listing"),
        "default_value" => array("varchar(255)","Default value"),
        "required" => array("tinyint","Required for user to fill out"),
        "tablename" => array("varchar(255)","Name of table with values")
    ),
    "user_attribute" => array(
        "attributeid" => array("integer not null","attribute"),
        "userid" => array("integer not null","user"),
        "value" => array("integer","Value of this attribute for this user"),
        "primary key" => array("(attributeid,userid)","PKey")
    ),
    "sendprocess" => array( # keep track of running send processes to avoid to many running concurrently
        "id" => array("integer not null primary key auto_increment","ID"),
        "started" => array("datetime", "Start Time"),
        "modified" => array("timestamp","Modified"),
        "alive" => array("integer default 1","Is this process still alive?"),
        "ipaddress" => array("varchar(50)","IP Address of who started it")
    )
);

?>
